/*
    Solutie ce determina secv. palindromica in O(Lmax^2), 
    Lmax - lungimea maxima a unui sir
    optimizata 100p
    prof. Eugen Nodea

*/


# include <fstream>
# include <cstring>
# include <queue>
using namespace std;

ifstream f("secvpal.in");
ofstream g("secvpal.out");

char s[50001];
queue <int> q;
int n, i, L, nr, S;
int a[50001];

inline int lmax(char s[])
{
	int st, dr, centru;
	int k = 0, i, p = 0;
	int Max = 1, n = strlen(s);
	//pot avea un subsir pald. de lungime para sau impara
	for(p=0; p<=1; ++p)
	{
		for(i=0; i<n; ++i)
		{
		    //alegem centrul palindromului
			centru = i;
			st = dr = centru;   // palindrom cu nr. elem. par
			k = -1;
			if(p == 1)          // palindrom cu nr. elem. impar
			{
				++dr;
				k = 0;
			}
			//incercam sa marim palindromul in stanga si dreapta
			while(s[st] == s[dr] && st>=0 && dr<n)
			{
                		k += 2;
                		--st; ++dr;
			}
			if(k > Max)
			{
				Max = k;
			}
		}
	}
    return Max;
}

int main()
{
    f>>n>>L; f.get();
    for (i=1; i<=n; ++i)
    {
        f.getline(s,50001);
        a[i] = lmax(s);
    }

    q.push(0);
    i = 0; S = 0; nr = 0;
    while (!q.empty())
    {
        S = S - q.front();
        while (S<L && i<n)
        {
            S += a[++i];
            q.push(a[i]);
        }
        if (S == L) ++nr;
        q.pop();
    }

    g<< nr <<'\n';

    return 0;
}

