// varianta cu backtracking si precalculare exponenti

#include <fstream>
#define nmax 10000001

using namespace std;

ifstream f("desc.in");
ofstream g("desc.out");


char v[nmax];
int w[nmax/5],wexp[nmax/4];
int st[25];
long q;

// Ciurul lui Eratostene
int ciur(int n) 
{
  int i, j, k = 0, nr = 0,f,t;
  for (i = 2; i <= n; ++i) {
    if (v[i] == 0) {
      nr++;
      for (j = i + i; j <= n; j += i) {
        v[j] = 1;
      }
    }
  }
  
  for(i=2;i<=n;i++)
	  if (!v[i]) w[++k]=i;
  
  // precalculez exponentii   
  for(i=1;i<=nr;i++)
  {
	 f=0;t=nmax;
	 while (t>1) {f++;t=t/w[i];}
	 wexp[i]=f;
  }	 
  
 return nr;
}

void afisare(int k,int prim)
{
int i;
g<<prim<<" "<<k-1<<" ";	
for(i=1;i<k;i++)
	g<<st[i]<<" ";
g<<"\n";
}

void back(int k, int prim, int we)
{
int i,j;	
long long s=0,p=1;
bool ok;

for(i=1;i<k;i++) 
	{
	p=1;	
	for(j=1;j<=st[i];j++)
		p=p*prim;
	s=s+p;
	}

 if (s==q) afisare(k,prim);
	 else
		 if (s<q)
			for(i=0;i<=we;i++)
					{
					st[k]=i;
					ok=true;
					if (st[k]<=st[k-1]&&k>1) ok=false;
					if (ok) back(k+1, prim, we);
					}   
		 	
}
int main()
{
int i,np,k=1;
f>>q;
np=ciur(q);
for(i=1;i<=np;i++)
	back(k,w[i],wexp[i]);

f.close();
g.close();

return 0;
}


