// Knapsack + Greedy 
// 100 puncte
// Constantin Galatan

#include <fstream>
#include <algorithm>
using namespace std;
#define DIM 1000
#define DIM2 50001
ifstream fin("pirati.in");
ofstream fout("pirati.out");
int S, C, R;

int c[DIM], r[DIM];
int used[DIM];
bool s[DIM2];
int t[DIM2];
void Read();
void Dyn();
int maxp = 0,  imaxp;

int main()
{
    Read();
    Dyn();
    bool ok = false;
    int cuf = maxp;
    if ( maxp == S )
    {
        fout << cuf << '\n';
        ok = true;
    }
    // Adaug pirati din primul cerc

    if ( maxp < S )
        for (int i = 0; i < C; ++i )
            if ( !used[c[i]] )
            {
                // adaug o parte din cercul acesta
                maxp += (S - maxp);
                cuf = maxp - 1;   // cuferele sunt cu unu mai putin
                ok = true;
                fout << cuf << '\n';
                break;
            }

    // nu ajung cercurile, adaug randuri
    if ( !ok )
    {
        // cele mari, primele
        sort(r, r + R, greater<int>() );
        for ( int i = 0; i < R; ++i )
        {
            if ( maxp + r[i] <= S )
            {
                maxp += r[i];
                cuf += r[i] - 1;
            }
            else
                if ( maxp + r[i] > S )
                {
                    cuf = cuf + (S - maxp ) - 1;
                    maxp = S;
                }

            if (maxp == S )
            {
                ok = true;
                break;
            }
        }

        fout << cuf << '\n';
    }

    return 0;
}

void Dyn()
{
    s[0] = true; t[0] = 0;
     for ( int i = 0; i < C; ++i )
            for ( int j = S - c[i]; j >= 0; --j )
                if ( s[j] && !s[j + c[i]])
                {
                    s[j + c[i]] = true;
                    if ( j + c[i] <= S )
                    {
                        maxp= max(maxp, j + c[i]);
                        imaxp = i;
                        t[j + c[i]] = c[i];
                    }
                }
    for ( int j = maxp; j > 0; j -= t[j] )
    {
        used[t[j]] = true;
    }
}

void Read()
{
    fin >> S >> C >> R;
    for ( int i = 0; i < C; ++i )
        fin >> c[i];
    for ( int i = 0; i < R; ++i )
        fin >> r[i];
    fin.close();
}

